//+---------------------------------------------------------------------------
//  PAZZMA.C - Windows GUI v.0.9
//  by Slava Razbickiy - rasla@mail.ru
//+---------------------------------------------------------------------------

#include <windows.h>
#include <Shlobj.h> // SHBrowseForFolder
#include <commctrl.h> // StatusBar, ProgressBar
//#include <mmsystem.h> // PlaySound - GCC "undefined reference to `PlaySoundA@12'", so LINKER -lwinmm
#include <stdio.h> // sscanf, sprintf, strstr
#include "inpout32.h"
#include "Pazzma.h"
#include "Pazzma_lib.c"

//  LIB-  - PlaySound
//#pragma comment(lib, "winmm.lib")

/*<---------------------------------------------------------------------->*/
HICON hIcon;
HDC	hDC;
HFONT hFont;
PAINTSTRUCT ps;
WNDCLASSEX wce;
MSG msgp;
RECT rc;

//   - 
char	BtnCls[]="BUTTON",EditCls[]="EDIT",StatCls[]="STATIC";
char    ProBarCls[]="msctls_progress32",StatusBarCls[]="msctls_statusbar32";
char    btn1[]=" 1 ",btn2[]="",btn4[]=" ";
char	btn5[]="   ", btn6[]="", btn7[]=" ";
char	btn8[]="  ", btn9[]=" 50 ", btn10[]="...";
char    btn11[]="?";
char	cbx1[]="-   (50 )",cbx2[]="-   (150-450 )";
char	cbx3[]="-   (1-10 k)",cbx4[]="   C (12-50 B)";
char	cbx5[]="   C (6-50 B, )",cbx6[]="  ";
char    cbx7[]=" ";
char	stat1[]=" ", esc_test[]="  (ESC)";

// MainWindow Elements
int	*lp,WndChildList[]={
// WndClass, WndTitle, Style, x,y, w,h, ID
	(DWORD)StatCls,(DWORD)stat1,SS_LEFT, 60,15,55,15, -1,			//  
	(DWORD)EditCls,0,ES_NUMBER|WS_BORDER, 120,11,80,23, ID_EDIT1,	// EDIT ( )
	(DWORD)BtnCls,(DWORD)btn2,BS_CENTER, 210,10,150,25, ID_BTN2,		// 
	(DWORD)BtnCls,(DWORD)btn1,BS_CENTER, 50,40,150,25, IDOK,		// 
	(DWORD)BtnCls,(DWORD)btn9,BS_CENTER, 210,40,150,25, ID_BTN_C50,		//  50

	(DWORD)BtnCls,0,BS_CENTER|BS_GROUPBOX, 30,70,340,235, -1,	// 
	(DWORD)BtnCls,(DWORD)cbx7,BS_CHECKBOX, 90,70,200,15, ID_CBX_UU,	//  

	(DWORD)BtnCls,(DWORD)cbx1,BS_CHECKBOX|WS_DISABLED, 45,90,300,15, ID_CBX1,	// -  (50 )
	(DWORD)BtnCls,(DWORD)cbx2,BS_CHECKBOX|WS_DISABLED, 45,110,300,15, ID_CBX2,	// -  (150-450 k)
	(DWORD)BtnCls,(DWORD)cbx3,BS_CHECKBOX|WS_DISABLED, 45,130,300,15, ID_CBX3,	// -  (1-10 k)
	(DWORD)BtnCls,(DWORD)cbx4,BS_CHECKBOX|WS_DISABLED, 45,150,300,15, ID_CBX4,	//     (12-22 B)
	(DWORD)BtnCls,(DWORD)cbx5,BS_CHECKBOX|WS_DISABLED, 45,170,300,15, ID_CBX5,	//     (27-40 B)
	(DWORD)BtnCls,(DWORD)cbx6,BS_CHECKBOX, 45,190,300,15, ID_CBX6,	//   
	(DWORD)BtnCls,(DWORD)btn4,BS_CENTER, 60,215,280,25, ID_BTN_TEST,		//  

	(DWORD)BtnCls,0,BS_CHECKBOX, 45,250,15,15,ID_CBX7,	// AutoSave Checkbox
	(DWORD)BtnCls,(DWORD)btn5,BS_CENTER|WS_DISABLED, 60,245,260,25, ID_BTN_SAVE,	//    
	(DWORD)BtnCls,(DWORD)btn11,BS_CENTER, 325,245,15,25, ID_BTN_DIRP,	//    
	(DWORD)BtnCls,(DWORD)btn10,BS_CENTER, 345,245,20,25, ID_BTN_DIR,	//    
	(DWORD)BtnCls,(DWORD)btn8,BS_CENTER|WS_DISABLED, 60,275,280,25, ID_BTN_LASTREP,	//   

	(DWORD)BtnCls,(DWORD)btn7,BS_CENTER, 20,310,160,25, IDHELP,		//  
	(DWORD)BtnCls,(DWORD)btn6,BS_CENTER, 220,310,160,25, IDCANCEL,	// 

    (DWORD)StatusBarCls,(DWORD)ProgName,WS_VISIBLE|WS_CHILD, 0,0,0,0, ID_STATUS,	// 
	0};
//  
int	sbParts[]={200,250,300,-1};
// 
LOGFONT font={
	14,0,0,0, FW_NORMAL, 0,0,0, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS,
	CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FIXED_PITCH, "Verdana" };

//  :
/*   ,
  ,  ,  
  0 -  .
*/
int	FreqLList[]={150,
	50,7000,25000,
	0};
int	FreqMList[]={100,
	150,15000,35000,
	251,3000,13000,
	350,1500,7000,
	450,100,6000,
	0};
int	FreqHList[]={50,
	1000,50,3000,
	2000,50,3000,
	3000,50,3000,
	4000,50,3000,
	7000,50,3000,
	10000,50,3000,
	0};

//     
typedef VOID (*MYPROC)();
MYPROC lpProcess;
HINSTANCE hTrd, hTrd2;

//   
char	buf[1024];

void __fastcall StopTest(){ //  
//	if( gStatus&STATUS_TESTING ){
	    PlaySound( NULL,0,0);
        SetDlgItemText( hWnd, ID_BTN_TEST, btn4);
        Status( ProgName, "", "", 100);
        gStatus &= ~STATUS_TESTING; //   
//        Error(" !");
  //      }
}
int __fastcall TestInc( int *offs, int flag){ //      
int a;
	if( gStatus& flag) return 0;
	a= *(offs);
	if( a<2 ) a++;
//  ,     1  3 
	if(a == 2){
		gStatus |= flag;
		a= Amp;
		}
	*(offs) = a;
	return a;
}

int WINAPI lptThread(){ // ,   LPT-   
short b;
/*  LPT Status Byte
N11 1xxx xxxx "3Io -"
N10 x0xx xxxx "3Io +"
N12 xx0x xxxx "3Uo +"
N13 xxx0 xxxx "3Uo -"
N32 xxxx 0xxx "3Uo "

AllWorkByte 1000 0xxx - 0x80
AllRestByte 0111 1xxx - 0x7F
*/
#define LPT_BASE 0x378
//#define LPT_BASE 0xE800

  while( gStatus&STATUS_TESTING ){
    if( gStatus&STATUS_WAVING ){
      b = Inp32( LPT_BASE+1 );  //   LPT-
      if( !(b& 0x08) ) TestInc( &U3Uo,  AMP5);
      if( !(b& 0x10) ) TestInc( &U3Uom, AMP4);
      if( !(b& 0x20) ) TestInc( &U3Uop, AMP3);
      if( !(b& 0x40) ) TestInc( &U3Iop, AMP2);
      if(  (b& 0x80) ) TestInc( &U3Iom, AMP1);
    }
  }
  return 1;
}
void WINAPI Thread(){ //       
	(lpProcess)();
    ExitThread(0);
}
int WINAPI TestProc(){ //   
	GetLocalTime( &t); //   
	ZeroMemory( Report, sizeof(Report) );    //  
// " "   
    ZeroMemory( wave_silent, sizeof(wave_silent));
    memcpy( wave_silent, wavhead, sizeof( wavhead) );
    PlaySound( wave_silent, 0, SND_ASYNC|SND_LOOP|SND_MEMORY);
//     LPT-
    lpProcess= (MYPROC)lptThread;    // ,   LPT-
	CreateThread( 0,2048, (LPTHREAD_START_ROUTINE)Thread,0,0, (LPDWORD)&hTrd2);
	SetThreadPriority( hTrd2, THREAD_PRIORITY_ABOVE_NORMAL);
// -  
    xProgress = 0;
	Status( cbx1, "", "", 0);
	if( gStatus&NEEDTEST1 ) TestFreq( FreqLList);

    Status( cbx2, "", "", 10);
	if( gStatus&NEEDTEST2 ) TestFreq( FreqMList);

    Status( cbx3, "", "", 45);
	if( gStatus&NEEDTEST3 ) TestFreq( FreqHList);
//    C
    xProgress = 70;
	Status( cbx4, "", "", 70);
	if( gStatus&NEEDTEST4 ) TestLowFreq( 12000,50000,100, 0);

    xProgress = 80;
	Status( cbx5, "", "", 80);
	if( gStatus&NEEDTEST5 ) TestLowFreq( 6000,50000,100, 88200);
//  
    xProgress = 90;
	Status( cbx6, "", "", 90);
	if( gStatus&NEEDTEST6 ) ProcessWorkFile();
//  
	Status( " ", "","", 100);
	SaveReport(0);
	if( gStatus&AUTOSAVE ) SaveReport( AUTOSAVE);
//   "  "  "  "
	EnableWindow( GetDlgItem( hWnd, ID_BTN_SAVE), 1);
	EnableWindow( GetDlgItem( hWnd, ID_BTN_LASTREP), 1);
//   (   lptTread() )
	StopTest();
//      
	sprintf( buf, "notepad %s", SaveName);
	Run( buf, 0);
    return 1; // OK
}

int WINAPI OpenDir(){ //      
char title[]="    ";
BROWSEINFO bi;
LPITEMIDLIST pidl;

    ZeroMemory( &bi, sizeof(bi) );
    bi.hwndOwner = hWnd;
    //bi.pidlRoot = NULL;
    bi.ulFlags = BIF_NEWDIALOGSTYLE;// BIF_RETURNONLYFSDIRS;
    bi.lpszTitle = title;
    bi.pszDisplayName = bu;
    if( !( pidl = SHBrowseForFolder( &bi)) ) return 0; // Cancel
    SHGetPathFromIDList(pidl, SaveDir);
    return 1;
}
int WINAPI OpenFileName(char *Filter){ //     
OPENFILENAME ofn;
    ZeroMemory( &ofn, sizeof(OPENFILENAME));
	ofn.lStructSize= sizeof(ofn);
	ofn.hwndOwner = hWnd;
	ofn.lpstrTitle= Filter;
	ofn.lpstrFilter= Filter;
	ofn.lpstrFile= File;
	ofn.nMaxFile= 1024;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags= OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;
	if ( !GetOpenFileName( &ofn) ) return 0; // Error
	strcpy( Ext, &File[ofn.nFileExtension]);
	return 1;	// OK
}

void CalculateK(){ //   ,    
int z;
	sscanf( Ue, "%d", &z);
	kU = (float) z/0x4000;
	sscanf( Ue50, "%d", &z);
	kU50 = (float) z/0x4000;
	sscanf( Uu50, "%d", &z);
	kUu = (float) z/0x4000/kU50;
}

LRESULT CALLBACK DlgAbout(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){ //    "About"
	switch( msg){
    case WM_COMMAND:
        if (wParam == IDCANCEL){
            EndDialog( hDlg, LOWORD(wParam));
            }
        break;
	}
    return 0;
}
LRESULT CALLBACK DlgClbrt(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){ //    " 1000 "
	switch( msg){
    case WM_COMMAND:
        if (wParam == IDCANCEL){
			PlaySound( NULL, 0, 0);
			GetDlgItemText( hDlg, ID_EDIT1, Ue, 7);
			CalculateK();
			gStatus |= STATUS_CALIBRATED;
            EndDialog( hDlg, LOWORD(wParam));
            }
        break;
	case WM_INITDIALOG:
		SetDlgItemText( hDlg, ID_EDIT1, Ue);
		MakeWave( 1000, 0x4000, 0, 22050, PeriodLen(1000,250), 0, PeriodLen(1000,250), 0 );
		//SaveWav();
		PlaySound( wave, 0, SND_ASYNC|SND_LOOP|SND_MEMORY);
		break;
	}
    return 0;
}
LRESULT CALLBACK DlgClbrt50(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){ //    " 50 "
	switch( msg){
    case WM_COMMAND:
        if (wParam == IDCANCEL){
			PlaySound( NULL, 0, 0);
			GetDlgItemText( hDlg, ID_EDIT1, Ue50, 7);
			GetDlgItemText( hDlg, ID_EDIT2, Uu50, 7);
			CalculateK();
			gStatus |= STATUS_CALIBRATED;
            EndDialog( hDlg, LOWORD(wParam));
            }
        break;
	case WM_INITDIALOG:
		SetDlgItemText( hDlg, ID_EDIT1, Ue50);
		SetDlgItemText( hDlg, ID_EDIT2, Uu50);
		MakeWave( 50, 0x4000, 0, 22050, PeriodLen( 50,12), 0, PeriodLen( 50,12), 0 );
        //SaveWav();
		PlaySound( wave, 0, SND_ASYNC|SND_LOOP|SND_MEMORY);
		break;
	}
    return 0;
}
LRESULT CALLBACK DlgSelWork(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){ //    " "
// sel440  = 440, 10000v, sel_offset=64
// sel1000 = 1000, 7000v, sel_offset=28
	switch( msg){
    case WM_COMMAND:
        switch( wParam){
            case IDCANCEL:
                PlaySound( NULL, 0, 0);
                EndDialog( hDlg, LOWORD(wParam));
                break;
			case ID_450:
				Freq = 440;
				Volt = 10000;
				Sel_Off = 64;
				goto CheckFreq;
			case ID_1000:
				Freq = 1000;
				Volt = 7000;
				Sel_Off = 28;
CheckFreq:		CheckRadioButton( hDlg, ID_450, ID_1000, wParam);
				goto MakeSound;
			case ID_SEL:
				Sel = 1;
				goto CheckSel;
			case ID_NSEL:
				Sel = 0;
CheckSel:		CheckRadioButton( hDlg, ID_SEL, ID_NSEL, wParam);
MakeSound:		if( Sel )	MakeSWave( Freq, Volt, Sel_Off, 0);
				else	    MakeSWave( Freq, Volt, 0, Sel_Off);
                PlaySound( wave, 0, SND_ASYNC|SND_LOOP|SND_MEMORY);
				break;
            }
        break;
	case WM_INITDIALOG:
        CheckDlgButton( hDlg, ID_SEL, 1);
        Sel = 1;
        PostMessage( hDlg, WM_COMMAND, ID_450, 0);
        break;
	}
    return 0;
}

LRESULT CALLBACK WndProc(HWND hwnd,UINT msg,WPARAM wPar,LPARAM lPar){
    switch (msg){
	case WM_CREATE:
		hWnd = hwnd;
// Font
		hFont = CreateFontIndirect( &font);
// Create CHILD-ELEMENTS
		lp = &WndChildList[0];
		do{
			hStat = CreateWindowEx( 0, (LPSTR) *lp, (LPSTR) *(lp+1),
				*(lp+2)|WS_VISIBLE|WS_CHILD,
				*(lp+3), *(lp+4),
				*(lp+5), *(lp+6),
				hwnd, 0, hInst, 0);
			SetWindowLong( hStat, GWL_ID, *(lp+7) );
			SendMessage( hStat, WM_SETFONT,(WPARAM) hFont, 0);
			lp+=8;
			} while (*lp != 0);
// StatusBar
//		hStat -       
		SendMessage( hStat, SB_SETPARTS, 4, (LPARAM) &sbParts);
// ProgressBar
		GetClientRect( hStat, &rc);
		hProgress = CreateWindowEx(0,ProBarCls,0,WS_VISIBLE|WS_CHILD|PBS_SMOOTH,295,2,100,rc.bottom-4,hStat,0,hInst,0);
		Status( ProgName, 0, 0, 100);
		SetDlgItemText( hwnd, ID_EDIT1, PzzmNum);  // Set Report Number
//  1..5 ,  IptOut32.DLL  !
        if( useIO) for( tInt=ID_CBX1; tInt<ID_CBX6; tInt++){
            EnableWindow( GetDlgItem( hWnd, tInt), 1);}
        break;
	case WM_PAINT:
		hDC = BeginPaint( hwnd, &ps);
		EndPaint( hwnd, &ps);
		break;
	case WM_DESTROY:
		ShowWindow( hwnd, SW_HIDE);
		DeleteObject( hFont);
		PostQuitMessage(0);
		break;
    case WM_KEYUP:
		if(wPar == VK_ESCAPE) StopTest();
		break;
    case WM_COMMAND:
        if (gStatus&STATUS_TESTING){    //   Ĩ
            if (wPar == ID_BTN_TEST) StopTest(); //   ""
            }
		else switch( LOWORD( wPar)){
		    case ID_EDIT1:
				if( HIWORD(wPar) == EN_CHANGE){
					GetDlgItemText(hwnd, ID_EDIT1, PzzmNum, 11);
					}
				break;
			case IDHELP:
				DialogBoxParam( hInst, (LPSTR) DLG_AB, hwnd, (DLGPROC) DlgAbout,0);
				break;
			case IDOK:
				DialogBoxParam( hInst, (LPSTR) DLG_CLBRT, hwnd, (DLGPROC) DlgClbrt,0);
				break;
			case ID_BTN_C50:
				DialogBoxParam( hInst, (LPSTR) DLG_CLBRT50, hwnd, (DLGPROC) DlgClbrt50,0);
				break;
			case ID_BTN2:
				DialogBoxParam( hInst, (LPSTR) DLG_SELWORK, hwnd, (DLGPROC) DlgSelWork,0);
				break;
			case ID_BTN_TEST:
                gStatus|= STATUS_TESTING;
   				lpProcess= (MYPROC)TestProc;
				CreateThread( 0,2048, (LPTHREAD_START_ROUTINE)Thread,0,0, (LPDWORD)&hTrd);
                SetDlgItemText( hwnd, ID_BTN_TEST, esc_test);
                break;
            case ID_CBX6:
                tInt = 0;
                lpChar = cbx6;
                gStatus &= ~NEEDTEST6;
                if( !IsDlgButtonChecked( hwnd, ID_CBX6) ){
                    if (OpenFileName( Filt) && OpenWorkFile( File)){
                        tInt = 1;
                        lpChar = File;
                        gStatus |= NEEDTEST6;
                        CloseWorkFile();
                        }
				    }
                CheckDlgButton( hwnd, ID_CBX6, tInt);
                SetDlgItemText( hwnd, ID_CBX6, lpChar);
				break;
            case ID_CBX1...ID_CBX5:
			case ID_CBX7:
            	CheckDlgButton( hwnd, wPar, IsDlgButtonChecked( hwnd, wPar)^1);
				gStatus ^= 1<<(wPar-6992); //   NEEDTEST1...NEEDTEST5, AUTOSAVE
				break;
            case ID_CBX_UU:
                useUu = IsDlgButtonChecked( hwnd, ID_CBX_UU)^1;
                CheckDlgButton( hwnd, ID_CBX_UU, useUu);
                break;
            case ID_BTN_DIR:
                if( OpenDir() ){
                    sprintf( bu, "   :\n%s", SaveDir);
                    Error( bu);
                }
                break;
            case ID_BTN_DIRP:
                sprintf( bu, "   :\n %s", SaveDir);
                Error( bu);
                break;
			case ID_BTN_SAVE:
				SaveReport( AUTOSAVE);
            case ID_BTN_LASTREP:
                sprintf( buf, "notepad %s", SaveName);
				Run( buf, 0);
                break;
			case IDCANCEL:
				PostMessage( hwnd, WM_DESTROY, 0, 0);
				break;
            default:
				break;
			}
		break;
	default:
		return DefWindowProc(hwnd,msg,wPar,lPar);
	}
return 0;
}
int APIENTRY WinMain( HINSTANCE hinst, HINSTANCE hPrevInst, LPSTR lpCmdLine, INT nCmdShow){
//  InpOut32
    if( (useIO= InpOut32_Init()) == 0) Error("   InpOut32.DLL!");
//   
	GetProfileString( pzzm, Uetext,"16384", Ue, sizeof(Ue));
	GetProfileString( pzzm, Ue50text,"16384", Ue50, sizeof(Ue50));
	GetProfileString( pzzm, Uu50text,"16384", Uu50, sizeof(Uu50));
	GetProfileString( pzzm, PzzmNumtext,"1", PzzmNum, sizeof(PzzmNum));
    GetProfileString( pzzm, sdir,"C:\\", SaveDir, sizeof(SaveDir));
    GetProfileString( pzzm, lfile, "", File, sizeof(File));
	CalculateK();

/*	Freq = 150; Amp = 12000 ;
//  
			MakeWave( Freq,Amp ,kU, 22050, PeriodLen( Freq,Freq/4 ), 0, PeriodLen( Freq,Freq/4 ), useUu);
//     
//&wave[loff*2+2+sizeof(wavhead)], llen
            FadeWave( Freq, &wave[44146], PeriodLen( Freq,Freq/4 ) );
//&wave[roff*2+sizeof(wavhead)], rlen
            FadeWave( Freq, &wave[44], PeriodLen( Freq,Freq/4 ) );
            SaveWav();
*/
//  
	hInst = wce.hInstance = hinst;
	wce.cbSize = sizeof(wce);
	wce.style = CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
	wce.cbWndExtra = wce.cbClsExtra= 0;
	hIcon= wce.hIcon = wce.hIconSm= LoadIcon(hInst, MAKEINTRESOURCE(9000));
	wce.hCursor = LoadCursor(0,IDC_ARROW);
	wce.hbrBackground = (HBRUSH)(COLOR_BTNSHADOW);
	wce.lpszMenuName = 0;
	wce.lpfnWndProc = (WNDPROC)WndProc;
	wce.lpszClassName = ProgClass;
	RegisterClassEx( &wce);
//  
	CreateWindowEx( 0,ProgClass,ProgName,
		WS_MINIMIZEBOX|WS_MAXIMIZEBOX|WS_VISIBLE|WS_CAPTION|WS_BORDER|WS_SYSMENU,
		120,50, 410,395,
		0,0,hinst,0);
	ShowWindow( hWnd, SW_SHOWNORMAL);
	UpdateWindow( hWnd );
	while (GetMessage ( &msgp, 0, 0, 0)) {
		TranslateMessage( &msgp);
		DispatchMessage( &msgp);
		}
//  
	WriteProfileString( pzzm, Uetext, Ue);
	WriteProfileString( pzzm, Ue50text, Ue50);
	WriteProfileString( pzzm, Uu50text, Uu50);
	WriteProfileString( pzzm, PzzmNumtext, PzzmNum);
	WriteProfileString( pzzm, sdir, SaveDir);
//  InpOut32.DLL
    InpOut32_Exit();
	return 0;
}
